<?php

use App\Models\User;
use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('item_menu', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('item_menu_profile');
            $table->unsignedBigInteger('item_menu_menu');
            $table->timestamps();
            $table->softDeletes();
            $table->foreign('item_menu_profile')->references('id')->on('profile')->onDelete('cascade');
            $table->foreign('item_menu_menu')->references('id')->on('menu')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('item_menu');
    }
};
