<?php

use App\Models\User;
use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('users', function (Blueprint $table) {
            $table->id();
            $table->string('name');
            $table->string('email')->unique();
            $table->timestamp('email_verified_at')->nullable();
            $table->string('password');
            $table->string('user_last_name_one');
            $table->string('user_last_name_two');
            $table->string('user_document_type');
            $table->string('user_document');
            $table->string('user_birth');
            $table->string('user_city');
            $table->string('user_neighborhood');
            $table->string('user_address');
            $table->string('user_cellphone');
            $table->string('user_photo');
            $table->string('user_state');
            $table->float('user_age');
            $table->unsignedBigInteger('profile_code')->nullable();
            $table->rememberToken();
            $table->string('verified')->default(User::USER_NOT_VERIFIED);
            $table->string('verification_token')->nullable();
            $table->foreign('profile_code')->references('id')->on('profile')->onDelete('cascade');
            $table->timestamps();
            $table->softDeletes();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('users');
    }
};
